Index: drivers/dahdi/dahdi-base.c
===================================================================
--- drivers/dahdi/dahdi-base.c	(revision 7107)
+++ drivers/dahdi/dahdi-base.c	(working copy)
@@ -34,7 +34,54 @@
  * this program for more details.
  */
 
+#if defined(__FreeBSD__)
+#include <sys/param.h>
+#include <sys/bus.h>
+#include <sys/conf.h>
+#include <sys/ctype.h>
+#include <sys/kernel.h>
+#include <sys/fcntl.h>
+#include <sys/ioccom.h>
+#include <sys/libkern.h>
+#include <sys/malloc.h>
+#include <sys/module.h>
+#include <sys/poll.h>
+#include <net/ppp_defs.h>
+#include <sys/selinfo.h>
+#include <sys/syscallsubr.h>
 
+#include <machine/stdarg.h>
+
+#include "version.h"
+
+#define module_printk(level, fmt, args...) printf(fmt, ## args)
+
+#define FOP_ARGS_DECL		struct cdev *file
+#define FOP_ARGS		file
+
+#define FOP_OPEN_ARGS_DECL	FOP_ARGS_DECL, int oflags, int devtype, struct thread *td
+#define FOP_OPEN_ARGS		FOP_ARGS, oflags, devtype, td
+#define FOP_CLOSE_ARGS_DECL	FOP_ARGS_DECL, int fflag, int devtype, struct thread *td
+#define FOP_CLOSE_ARGS		FOP_ARGS, fflag, devtype, td
+#define FOP_IOCTL_ARGS_DECL	FOP_ARGS_DECL, u_long cmd, caddr_t data, int fflag, struct thread *td
+#define FOP_IOCTL_ARGS		FOP_ARGS, cmd, data, fflag, td
+
+#define FOP_READ_ARGS_DECL	FOP_ARGS_DECL, struct uio *uio, int ioflag
+#define FOP_READ_ARGS		FOP_ARGS, uio, ioflag
+#define FOP_WRITE_ARGS_DECL	FOP_ARGS_DECL, struct uio *uio, int ioflag
+#define FOP_WRITE_ARGS		FOP_ARGS, uio, ioflag
+#define FOP_POLL_ARGS_DECL	FOP_ARGS_DECL, int events, struct thread *td
+#define FOP_POLL_ARGS		FOP_ARGS, events, td
+#define FOP_MMAP_ARGS_DECL	FOP_ARGS_DECL, vm_offset_t offset, vm_paddr_t *paddr, int nprot
+#define FOP_MMAP_ARGS		FOP_ARGS, offset, paddr, nprot
+
+#define FOP_IO_SUCCESS(nbytes)	0
+
+typedef int read_retval_t;
+typedef int write_retval_t;
+typedef int poll_retval_t;
+
+#else /* !__FreeBSD__ */
 #include <linux/kernel.h>
 #include <linux/errno.h>
 #include <linux/module.h>
@@ -51,11 +98,44 @@
 
 #include <asm/atomic.h>
 
+#include <dahdi/version.h>
+
 #define module_printk(level, fmt, args...) printk(level "%s: " fmt, THIS_MODULE->name, ## args)
 
+#define FOP_ARGS_DECL		struct inode *inode, struct file *file
+#define FOP_ARGS		inode, file
+
+#define FOP_OPEN_ARGS_DECL	FOP_ARGS_DECL
+#define FOP_OPEN_ARGS		FOP_ARGS
+#define FOP_CLOSE_ARGS_DECL	FOP_ARGS_DECL
+#define FOP_CLOSE_ARGS		FOP_ARGS
+#define FOP_IOCTL_ARGS_DECL	FOP_ARGS_DECL, unsigned int cmd, unsigned long data
+#define FOP_IOCTL_ARGS		FOP_ARGS, cmd, data
+
+#define FOP_READ_ARGS_DECL	struct file *file, char *usrbuf, size_t count, loff_t *ppos
+#define FOP_READ_ARGS		file, usrbuf, count, ppos
+#define FOP_WRITE_ARGS_DECL	struct file *file, const char *usrbuf, size_t count, loff_t *ppos
+#define FOP_WRITE_ARGS		file, usrbuf, count, ppos
+#define FOP_POLL_ARGS_DECL	struct file *file, struct poll_table_struct *wait_table
+#define FOP_POLL_ARGS		file, wait_table
+#define FOP_MMAP_ARGS_DECL	struct file *file, struct vm_area_struct *vm
+#define FOP_MMAP_ARGS		file, vm
+
+#define FOP_IO_SUCCESS(nbytes)	(nbytes)
+
+typedef ssize_t read_retval_t;
+typedef ssize_t write_retval_t;
+typedef unsigned int poll_retval_t;
+#endif /* !__FreeBSD__ */
+
+#define DAHDI_MINOR_CTL		0
+#define DAHDI_MINOR_TRANSCODE	250
+#define DAHDI_MINOR_TIMER	253
+#define DAHDI_MINOR_CHANNEL	254
+#define DAHDI_MINOR_PSEUDO	255
+
 /* #define BUF_MUNGE */
 
-#include <dahdi/version.h>
 /* Grab fasthdlc with tables */
 #define FAST_HDLC_NEED_TABLES
 #include <dahdi/kernel.h>
@@ -91,9 +171,6 @@
 #define dev_to_ztchan(h) (((struct dahdi_hdlc *)(dev_to_hdlc(h)->priv))->chan)
 #define ztchan_to_dev(h) ((h)->hdlcnetdev->netdev)
 
-/* macro-oni for determining a unit (channel) number */
-#define	UNIT(file) MINOR(file->f_dentry->d_inode->i_rdev)
-
 /* names of tx level settings */
 static char *dahdi_txlevelnames[] = {
 "0 db (CSU)/0-133 feet (DSX-1)",
@@ -106,6 +183,247 @@
 "-22.5db (CSU)"
 } ;
 
+#if defined(__FreeBSD__)
+
+#if 0
+static void rlprintf(int pps, const char *fmt, ...)
+{
+	va_list ap;
+	static struct timeval last_printf;
+	static int count;
+
+	if (ppsratecheck(&last_printf, &count, pps)) {
+		va_start(ap, fmt);
+		vprintf(fmt, ap);
+		va_end(ap);
+	}
+}
+
+#define DPRINTF(fmt, args...)	rlprintf(10, "%s: " fmt, __FUNCTION__, ##args)
+#endif
+
+MALLOC_DEFINE(M_DAHDI, "dahdi", "DAHDI interface data structures");
+
+/*
+ * FCS lookup table as calculated by genfcstab.
+ */
+static u_short fcstab[256] = {
+	0x0000,	0x1189,	0x2312,	0x329b,	0x4624,	0x57ad,	0x6536,	0x74bf,
+	0x8c48,	0x9dc1,	0xaf5a,	0xbed3,	0xca6c,	0xdbe5,	0xe97e,	0xf8f7,
+	0x1081,	0x0108,	0x3393,	0x221a,	0x56a5,	0x472c,	0x75b7,	0x643e,
+	0x9cc9,	0x8d40,	0xbfdb,	0xae52,	0xdaed,	0xcb64,	0xf9ff,	0xe876,
+	0x2102,	0x308b,	0x0210,	0x1399,	0x6726,	0x76af,	0x4434,	0x55bd,
+	0xad4a,	0xbcc3,	0x8e58,	0x9fd1,	0xeb6e,	0xfae7,	0xc87c,	0xd9f5,
+	0x3183,	0x200a,	0x1291,	0x0318,	0x77a7,	0x662e,	0x54b5,	0x453c,
+	0xbdcb,	0xac42,	0x9ed9,	0x8f50,	0xfbef,	0xea66,	0xd8fd,	0xc974,
+	0x4204,	0x538d,	0x6116,	0x709f,	0x0420,	0x15a9,	0x2732,	0x36bb,
+	0xce4c,	0xdfc5,	0xed5e,	0xfcd7,	0x8868,	0x99e1,	0xab7a,	0xbaf3,
+	0x5285,	0x430c,	0x7197,	0x601e,	0x14a1,	0x0528,	0x37b3,	0x263a,
+	0xdecd,	0xcf44,	0xfddf,	0xec56,	0x98e9,	0x8960,	0xbbfb,	0xaa72,
+	0x6306,	0x728f,	0x4014,	0x519d,	0x2522,	0x34ab,	0x0630,	0x17b9,
+	0xef4e,	0xfec7,	0xcc5c,	0xddd5,	0xa96a,	0xb8e3,	0x8a78,	0x9bf1,
+	0x7387,	0x620e,	0x5095,	0x411c,	0x35a3,	0x242a,	0x16b1,	0x0738,
+	0xffcf,	0xee46,	0xdcdd,	0xcd54,	0xb9eb,	0xa862,	0x9af9,	0x8b70,
+	0x8408,	0x9581,	0xa71a,	0xb693,	0xc22c,	0xd3a5,	0xe13e,	0xf0b7,
+	0x0840,	0x19c9,	0x2b52,	0x3adb,	0x4e64,	0x5fed,	0x6d76,	0x7cff,
+	0x9489,	0x8500,	0xb79b,	0xa612,	0xd2ad,	0xc324,	0xf1bf,	0xe036,
+	0x18c1,	0x0948,	0x3bd3,	0x2a5a,	0x5ee5,	0x4f6c,	0x7df7,	0x6c7e,
+	0xa50a,	0xb483,	0x8618,	0x9791,	0xe32e,	0xf2a7,	0xc03c,	0xd1b5,
+	0x2942,	0x38cb,	0x0a50,	0x1bd9,	0x6f66,	0x7eef,	0x4c74,	0x5dfd,
+	0xb58b,	0xa402,	0x9699,	0x8710,	0xf3af,	0xe226,	0xd0bd,	0xc134,
+	0x39c3,	0x284a,	0x1ad1,	0x0b58,	0x7fe7,	0x6e6e,	0x5cf5,	0x4d7c,
+	0xc60c,	0xd785,	0xe51e,	0xf497,	0x8028,	0x91a1,	0xa33a,	0xb2b3,
+	0x4a44,	0x5bcd,	0x6956,	0x78df,	0x0c60,	0x1de9,	0x2f72,	0x3efb,
+	0xd68d,	0xc704,	0xf59f,	0xe416,	0x90a9,	0x8120,	0xb3bb,	0xa232,
+	0x5ac5,	0x4b4c,	0x79d7,	0x685e,	0x1ce1,	0x0d68,	0x3ff3,	0x2e7a,
+	0xe70e,	0xf687,	0xc41c,	0xd595,	0xa12a,	0xb0a3,	0x8238,	0x93b1,
+	0x6b46,	0x7acf,	0x4854,	0x59dd,	0x2d62,	0x3ceb,	0x0e70,	0x1ff9,
+	0xf78f,	0xe606,	0xd49d,	0xc514,	0xb1ab,	0xa022,	0x92b9,	0x8330,
+	0x7bc7,	0x6a4e,	0x58d5,	0x495c,	0x3de3,	0x2c6a,	0x1ef1,	0x0f78
+};
+
+static int
+request_module(const char *fmt, ...)
+{
+	va_list ap;
+	char modname[128];
+	int fileid;
+
+	va_start(ap, fmt);
+	vsnprintf(modname, sizeof(modname), fmt, ap);
+	va_end(ap);
+
+	return kern_kldload(curthread, modname, &fileid);
+}
+
+static void
+handle_selwakeup(void *context, int pending)
+{
+	struct selinfo * sel = context;
+	selwakeup(sel);
+}
+
+/*
+ * Concatenate src on the end of dst.  At most strlen(dst)+n+1 bytes
+ * are written at dst (at most n+1 bytes being appended).  Return dst.
+ */
+static char *
+strncat(char * __restrict dst, const char * __restrict src, size_t n)
+{
+	if (n != 0) {
+		char *d = dst;
+		const char *s = src;
+
+		while (*d != 0)
+			d++;
+		do {
+			if ((*d = *s++) == 0)
+				break;
+			d++;
+		} while (--n != 0);
+		*d = 0;
+	}
+	return (dst);
+}
+
+#define UNIT(file)	minor(file)
+
+struct dahdi_fp {
+	int fflags;		/**< file flags */
+	void *private_data;	/**< private data */
+};
+
+static void
+dahdi_fp_free(void *fp)
+{
+	free(fp, M_DAHDI);
+}
+
+static int
+dahdi_get_fp(struct cdev *dev, struct dahdi_fp **pfp)
+{
+	int error = devfs_get_cdevpriv((void **) pfp);
+	if (error == ENOENT) {
+		*pfp = malloc(sizeof(struct dahdi_fp), M_DAHDI, M_NOWAIT | M_ZERO);
+		if (*pfp == NULL)
+			return _RETVAL(ENOMEM);
+
+		error = devfs_set_cdevpriv(*pfp, dahdi_fp_free);
+		if (error) {
+			dahdi_fp_free(*pfp);
+			return _RETVAL(ENXIO);
+		}
+	} else if (error) {
+		return (error);
+	}
+
+	return 0;
+}
+
+static int
+dahdi_get_flags(struct cdev *dev)
+{
+	int error;
+	struct dahdi_fp *fp;
+
+	error = devfs_get_cdevpriv((void **) &fp);
+	if (error || fp == NULL)
+		return 0;
+
+	return fp->fflags;
+}
+
+static void
+dahdi_set_flags(struct cdev *dev, int fflags)
+{
+	int error;
+	struct dahdi_fp *fp;
+
+	error = dahdi_get_fp(dev, &fp);
+	if (error)
+		return;
+
+	fp->fflags = fflags;
+}
+
+static void *
+dahdi_get_private_data(struct cdev *dev)
+{
+	int error;
+	struct dahdi_fp *fp;
+
+	error = devfs_get_cdevpriv((void **) &fp);
+	if (error || fp == NULL)
+		return NULL;
+
+	return fp->private_data;
+}
+
+static void
+dahdi_set_private_data(struct cdev *dev, void *private_data)
+{
+	int error;
+	struct dahdi_fp *fp;
+
+	error = dahdi_get_fp(dev, &fp);
+	if (error)
+		return;
+
+	fp->private_data = private_data;
+}
+
+static struct cdev *dev_ctl = NULL;
+
+static d_open_t         dahdi_open;
+static d_close_t        dahdi_release;
+static d_read_t         dahdi_read;
+static d_write_t        dahdi_write;
+static d_ioctl_t        dahdi_ioctl;
+static d_poll_t         dahdi_poll;
+static d_mmap_t         dahdi_mmap;
+
+static struct cdevsw dahdi_devsw = {
+	.d_version	= D_VERSION,
+	.d_open		= dahdi_open,
+	.d_close	= dahdi_release,
+	.d_read		= dahdi_read,
+	.d_write	= dahdi_write,
+	.d_ioctl	= dahdi_ioctl,
+	.d_poll		= dahdi_poll,
+	.d_mmap		= dahdi_mmap,
+	.d_name		= "dahdi",
+#if __FreeBSD_version >= 800039
+	.d_flags	= D_PSEUDO | D_TRACKCLOSE | D_NEEDMINOR
+#else
+	.d_flags	= D_PSEUDO | D_TRACKCLOSE
+#endif
+};
+
+#else /* !__FreeBSD__ */
+/* macro-oni for determining a unit (channel) number */
+#define	UNIT(file) MINOR(file->f_dentry->d_inode->i_rdev)
+
+static int
+dahdi_get_flags(struct file *file)
+{
+	if (!file)
+		return 0;
+
+	return file->f_flags;
+}
+
+static void *
+dahdi_get_private_data(struct file *file)
+{
+	return file->private_data;
+}
+
+static void
+dahdi_set_private_data(struct file *file, void *private_data)
+{
+	file->private_data = private_data;
+}
+
 EXPORT_SYMBOL(dahdi_transcode_fops);
 EXPORT_SYMBOL(dahdi_init_tone_state);
 EXPORT_SYMBOL(dahdi_mf_tone);
@@ -186,6 +504,7 @@
 #define class_create class_simple_create
 #define class_destroy class_simple_destroy
 #endif
+#endif /* !__FreeBSD__ */
 
 static int deftaps = 64;
 
@@ -227,8 +546,10 @@
 static sumtype *conf_sums_prev;
 
 static struct dahdi_span *master;
+#if !defined(__FreeBSD__)
 static struct file_operations dahdi_fops;
 struct file_operations *dahdi_transcode_fops = NULL;
+#endif
 
 static struct {
 	int	src;	/* source conf number */
@@ -303,7 +624,7 @@
 	.mfr2_tonelen = DEFAULT_MFR2_LENGTH,
 };
 
-static int dahdi_chan_ioctl(struct inode *inode, struct file *file, unsigned int cmd, unsigned long data, int unit);
+static int dahdi_chan_ioctl(FOP_IOCTL_ARGS_DECL, int unit);
 
 #if defined(CONFIG_DAHDI_MMX) || defined(ECHO_CAN_FP)
 #if (defined(CONFIG_X86) && !defined(CONFIG_X86_64)) || defined(CONFIG_I386)
@@ -364,10 +685,15 @@
 	int ping;		/* Whether we've been ping'd */
 	int tripped;	/* Whether we're tripped */
 	struct list_head list;
+#if defined(__FreeBSD__)
+	struct selinfo  sel;
+	struct task     selwakeup_task;
+#else
 	wait_queue_head_t sel;
+#endif
 };
 
-static LIST_HEAD(zaptimers);
+static _LIST_HEAD(zaptimers);
 
 #ifdef DEFINE_SPINLOCK
 static DEFINE_SPINLOCK(zaptimerlock);
@@ -416,10 +742,6 @@
 
 static u_char defgain[256];
 
-#if LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 10)
-#define __RW_LOCK_UNLOCKED() RW_LOCK_UNLOCKED
-#endif
-
 #ifdef DEFINE_RWLOCK
 static DEFINE_RWLOCK(zone_lock);
 static DEFINE_RWLOCK(chan_lock);
@@ -435,10 +757,14 @@
 #ifdef DEFINE_RWLOCK
 static DEFINE_RWLOCK(ecfactory_list_lock);
 #else
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 10)
+#define __RW_LOCK_UNLOCKED() RW_LOCK_UNLOCKED
+#endif
+
 static rwlock_t ecfactory_list_lock = __RW_LOCK_UNLOCKED();
 #endif
 
-static LIST_HEAD(ecfactory_list);
+static _LIST_HEAD(ecfactory_list);
 
 struct ecfactory {
 	const struct dahdi_echocan_factory *ec;
@@ -449,7 +775,9 @@
 {
 	struct ecfactory *cur;
 
+#if !defined(__FreeBSD__)
 	WARN_ON(!ec->owner);
+#endif
 
 	write_lock(&ecfactory_list_lock);
 
@@ -457,13 +785,13 @@
 	list_for_each_entry(cur, &ecfactory_list, list) {
 		if (cur->ec == ec) {
 			write_unlock(&ecfactory_list_lock);
-			return -EPERM;
+			return _RETVAL(EPERM);
 		}
 	}
 
 	if (!(cur = kzalloc(sizeof(*cur), GFP_KERNEL))) {
 		write_unlock(&ecfactory_list_lock);
-		return -ENOMEM;
+		return _RETVAL(ENOMEM);
 	}
 
 	cur->ec = ec;
@@ -887,7 +1215,11 @@
 
 	wake_up_interruptible(&chan->readbufq);
 	wake_up_interruptible(&chan->writebufq);
+#if defined(__FreeBSD__)
+	taskqueue_enqueue_fast(taskqueue_fast, &chan->selwakeup_task);
+#else
 	wake_up_interruptible(&chan->sel);
+#endif
 
 	return;
 }
@@ -908,6 +1240,15 @@
 /* sleep in user space until woken up. Equivilant of tsleep() in BSD */
 static int schluffen(wait_queue_head_t *q)
 {
+#if defined(__FreeBSD__)
+	int rc = tsleep(q, PZERO | PCATCH, "schluffen", 10);
+	switch (rc) {
+	case EINTR:
+	case ERESTART:
+		return rc;
+	}
+	return 0;
+#else /* !__FreeBSD__ */
 	DECLARE_WAITQUEUE(wait, current);
 
 	add_wait_queue(q, &wait);
@@ -920,9 +1261,10 @@
 	remove_wait_queue(q, &wait);
 
 	if (signal_pending(current))
-		return -ERESTARTSYS;
+		return _RETVAL(ERESTARTSYS);
 
 	return 0;
+#endif /* !__FreeBSD__ */
 }
 
 static inline void calc_fcs(struct dahdi_chan *ss, int inwritebuf)
@@ -961,7 +1303,7 @@
 	/* We need to allocate our buffers now */
 	if (j) {
 		if (!(newbuf = kcalloc(j * 2, numbufs, GFP_KERNEL)))
-			return -ENOMEM;
+			return _RETVAL(ENOMEM);
 	} else
 		newbuf = NULL;
 
@@ -1168,13 +1510,14 @@
 
 	list_for_each_entry(cur, &ecfactory_list, list) {
 		if (!strcmp(name_upper, cur->ec->name)) {
-			if (try_module_get(cur->ec->owner)) {
+#if !defined(__FreeBSD__)
+			if (!try_module_get(cur->ec->owner)) {
 				read_unlock(&ecfactory_list_lock);
-				return cur->ec;
-			} else {
-				read_unlock(&ecfactory_list_lock);
 				return NULL;
 			}
+#endif /* !__FreeBSD__ */
+			read_unlock(&ecfactory_list_lock);
+			return cur->ec;
 		}
 	}
 
@@ -1200,9 +1543,12 @@
 
 static void release_echocan(const struct dahdi_echocan_factory *ec)
 {
-	if (ec)
+	if (ec) {
+#if !defined(__FreeBSD__)
 		module_put(ec->owner);
+#endif
 }
+}
 
 /** 
  * close_channel - close the channel, resetting any channel variables
@@ -1323,7 +1669,7 @@
 	int res = 0;
 
 	if ((num >= DAHDI_TONE_ZONE_MAX) || (num < 0))
-		return -EINVAL;
+		return _RETVAL(EINVAL);
 
 	write_lock(&zone_lock);
 	if (tone_zones[num]) {
@@ -1331,7 +1677,7 @@
 			z = tone_zones[num];
 			tone_zones[num] = NULL;
 		} else {
-			res = -EBUSY;
+			res = _RETVAL(EBUSY);
 		}
 	}
 	write_unlock(&zone_lock);
@@ -1347,11 +1693,11 @@
 	int res = 0;
 
 	if ((num >= DAHDI_TONE_ZONE_MAX) || (num < 0))
-		return -EINVAL;
+		return _RETVAL(EINVAL);
 
 	write_lock(&zone_lock);
 	if (tone_zones[num]) {
-		res = -EINVAL;
+		res = _RETVAL(EINVAL);
 	} else {
 		res = 0;
 		tone_zones[num] = zone;
@@ -1370,7 +1716,7 @@
 	int base, max;
 
 	if (!chan->curzone)
-		return -ENODATA;
+		return _RETVAL(ENODATA);
 
 	switch (chan->digitmode) {
 	case DIGIT_MODE_DTMF:
@@ -1388,11 +1734,11 @@
 		max = DAHDI_TONE_MFR2_REV_MAX;
 		break;
 	default:
-		return -EINVAL;
+		return _RETVAL(EINVAL);
 	}
 
 	if ((tone < base) || (tone > max))
-		return -EINVAL;
+		return _RETVAL(EINVAL);
 
 	switch (chan->digitmode) {
 	case DIGIT_MODE_DTMF:
@@ -1407,7 +1753,7 @@
 	}
 
 	if (!playtone || !playtone->tonesamples)
-		return -ENOSYS;
+		return _RETVAL(ENOSYS);
 
 	chan->curtone = playtone;
 
@@ -1416,7 +1762,7 @@
 
 static int start_tone(struct dahdi_chan *chan, int tone)
 {
-	int res = -EINVAL;
+	int res = _RETVAL(EINVAL);
 
 	/* Stop the current tone, no matter what */
 	chan->tonep = 0;
@@ -1436,14 +1782,14 @@
 			module_printk(KERN_WARNING, "DAHDI: Cannot start tones until tone zone is loaded.\n");
 		}
 		/* Note that no tone zone exists at the moment */
-		res = -ENODATA;
+		res = _RETVAL(ENODATA);
 	} else if ((tone >= 0 && tone <= DAHDI_TONE_MAX)) {
 		/* Have a tone zone */
 		if (chan->curzone->tones[tone]) {
 			chan->curtone = chan->curzone->tones[tone];
 			res = 0;
 		} else { /* Indicate that zone is loaded but no such tone exists */
-			res = -ENOSYS;
+			res = _RETVAL(ENOSYS);
 		}
 	} else if (chan->digitmode == DIGIT_MODE_DTMF ||
 			chan->digitmode == DIGIT_MODE_MFR2_FWD ||
@@ -1451,7 +1797,7 @@
 		res = start_tone_digit(chan, tone);
 	} else {
 		chan->dialing = 0;
-		res = -EINVAL;
+		res = _RETVAL(EINVAL);
 	}
 
 	if (chan->curtone)
@@ -1471,7 +1817,7 @@
 		zone = default_zone;
 
 	if ((zone >= DAHDI_TONE_ZONE_MAX) || (zone < 0))
-		return -EINVAL;
+		return _RETVAL(EINVAL);
 
 	read_lock(&zone_lock);
 
@@ -1490,7 +1836,7 @@
 
 		spin_unlock_irqrestore(&chan->lock, flags);
 	} else {
-		res = -ENODATA;
+		res = _RETVAL(ENODATA);
 	}
 
 	read_unlock(&zone_lock);
@@ -1532,6 +1878,9 @@
 	might_sleep();
 
 	spin_lock_init(&chan->lock);
+#if defined(__FreeBSD__)
+	TASK_INIT(&chan->selwakeup_task, 0, handle_selwakeup, &chan->sel);
+#endif
 	if (!chan->master)
 		chan->master = chan;
 	if (!chan->readchunk)
@@ -1560,7 +1909,7 @@
 	if (DAHDI_MAX_CHANNELS == x) {
 		write_unlock_irqrestore(&chan_lock, flags);
 		module_printk(KERN_ERR, "No more channels available\n");
-		return -ENOMEM;
+		return _RETVAL(ENOMEM);
 	}
 
 	return 0;
@@ -1606,15 +1955,15 @@
 #endif
 	if (!ms) {
 		module_printk(KERN_NOTICE, "dahdi_net_open: nothing??\n");
-		return -EINVAL;
+		return _RETVAL(EINVAL);
 	}
 	if (test_bit(DAHDI_FLAGBIT_OPEN, &ms->flags)) {
 		module_printk(KERN_NOTICE, "%s is already open!\n", ms->name);
-		return -EBUSY;
+		return _RETVAL(EBUSY);
 	}
 	if (!(ms->flags & DAHDI_FLAG_NETDEV)) {
 		module_printk(KERN_NOTICE, "%s is not a net device!\n", ms->name);
-		return -EINVAL;
+		return _RETVAL(EINVAL);
 	}
 	ms->txbufpolicy = DAHDI_POLICY_IMMEDIATE;
 	ms->rxbufpolicy = DAHDI_POLICY_IMMEDIATE;
@@ -1645,7 +1994,7 @@
 	}
 	result = register_netdev(dev);
 	if (result != 0)
-		return -EIO;
+		return _RETVAL(EIO);
 #if LINUX_VERSION_CODE <= KERNEL_VERSION(2,6,14)
 	if (netif_carrier_ok(dev))
 		netif_carrier_off(dev); /* no carrier until DCD goes up */
@@ -1708,14 +2057,14 @@
             encoding != ENCODING_FM_MARK &&
             encoding != ENCODING_FM_SPACE &&
             encoding != ENCODING_MANCHESTER)
-                return -EINVAL;
+                return _RETVAL(EINVAL);
 
         if (parity != PARITY_NONE &&
             parity != PARITY_CRC16_PR0_CCITT &&
             parity != PARITY_CRC16_PR1_CCITT &&
             parity != PARITY_CRC32_PR0_CCITT &&
             parity != PARITY_CRC32_PR1_CCITT)
-                return -EINVAL;
+                return _RETVAL(EINVAL);
 
         dpriv->encoding = encoding;
         dpriv->parity = parity;*/
@@ -1805,7 +2154,7 @@
 #else
 static int dahdi_net_ioctl(hdlc_device *hdlc, struct ifreq *ifr, int cmd)
 {
-	return -EIO;
+	return _RETVAL(EIO);
 }
 #endif
 
@@ -1899,7 +2248,7 @@
 
 static int dahdi_ppp_ioctl(struct ppp_channel *ppp, unsigned int cmd, unsigned long flags)
 {
-	return -EIO;
+	return _RETVAL(EIO);
 }
 
 static struct ppp_channel_ops ztppp_ops =
@@ -1967,10 +2316,14 @@
 			}
 		}
 	chan->channo = -1;
+	spin_lock_destroy(&chan->lock);
+#if defined(__FreeBSD__)
+	taskqueue_drain(taskqueue_fast, &chan->selwakeup_task);
+#endif
 	write_unlock_irqrestore(&chan_lock, flags);
 }
 
-static ssize_t dahdi_chan_read(struct file *file, char *usrbuf, size_t count, int unit)
+static ssize_t dahdi_chan_read(FOP_READ_ARGS_DECL, int unit)
 {
 	struct dahdi_chan *chan = chans[unit];
 	int amnt;
@@ -1979,19 +2332,26 @@
 	unsigned long flags;
 
 	/* Make sure count never exceeds 65k, and make sure it's unsigned */
+#if defined(__FreeBSD__)
+	int count = uio->uio_resid & 0xfffff;
+#else
+	int ioflag = file->f_flags;
 	count &= 0xffff;
+#endif
+	if (count < 0)
+		return _RETVAL(EINVAL);
 
 	if (!chan)
-		return -EINVAL;
+		return _RETVAL(EINVAL);
 
 	if (count < 1)
-		return -EINVAL;
+		return _RETVAL(EINVAL);
 
 	for (;;) {
 		spin_lock_irqsave(&chan->lock, flags);
 		if (chan->eventinidx != chan->eventoutidx) {
 			spin_unlock_irqrestore(&chan->lock, flags);
-			return -ELAST /* - chan->eventbuf[chan->eventoutidx]*/;
+			return _RETVAL(ELAST) /* - chan->eventbuf[chan->eventoutidx]*/;
 		}
 		res = chan->outreadbuf;
 		if (chan->rxdisable)
@@ -1999,8 +2359,8 @@
 		spin_unlock_irqrestore(&chan->lock, flags);
 		if (res >= 0)
 			break;
-		if (file->f_flags & O_NONBLOCK)
-			return -EAGAIN;
+		if (ioflag & O_NONBLOCK)
+			return _RETVAL(EAGAIN);
 		rv = schluffen(&chan->readbufq);
 		if (rv)
 			return rv;
@@ -2039,8 +2399,12 @@
 					pass = 128;
 				for (x = 0; x < pass; x++)
 					lindata[x] = DAHDI_XLAW(chan->readbuf[res][x + pos], chan);
+#if defined(__FreeBSD__)
+				if (uiomove(lindata, pass << 1, uio))
+#else
 				if (copy_to_user(usrbuf + (pos << 1), lindata, pass << 1))
-					return -EFAULT;
+#endif
+					return _RETVAL(EFAULT);
 				left -= pass;
 				pos += pass;
 			}
@@ -2049,8 +2413,12 @@
 		if (amnt > chan->readn[res])
 			amnt = chan->readn[res];
 		if (amnt) {
+#if defined(__FreeBSD__)
+			if (uiomove(chan->readbuf[res], amnt, uio))
+#else
 			if (copy_to_user(usrbuf, chan->readbuf[res], amnt))
-				return -EFAULT;
+#endif
+				return _RETVAL(EFAULT);
 		}
 	}
 	spin_lock_irqsave(&chan->lock, flags);
@@ -2070,7 +2438,7 @@
 	}
 	spin_unlock_irqrestore(&chan->lock, flags);
 
-	return amnt;
+	return FOP_IO_SUCCESS(amnt);
 }
 
 static int num_filled_bufs(struct dahdi_chan *chan)
@@ -2096,20 +2464,27 @@
 	return range1 + range2;
 }
 
-static ssize_t dahdi_chan_write(struct file *file, const char *usrbuf, size_t count, int unit)
+static ssize_t dahdi_chan_write(FOP_WRITE_ARGS_DECL, int unit)
 {
 	unsigned long flags;
 	struct dahdi_chan *chan = chans[unit];
 	int res, amnt, oldbuf, rv, x;
 
 	/* Make sure count never exceeds 65k, and make sure it's unsigned */
+#if defined(__FreeBSD__)
+	int count = uio->uio_resid & 0xfffff;
+#else
+	int ioflag = file->f_flags;
 	count &= 0xffff;
+#endif
+	if (count < 0)
+		return _RETVAL(EINVAL);
 
 	if (!chan)
-		return -EINVAL;
+		return _RETVAL(EINVAL);
 
 	if (count < 1) {
-		return -EINVAL;
+		return _RETVAL(EINVAL);
 	}
 
 	for (;;) {
@@ -2123,17 +2498,17 @@
 		}
 		if (chan->eventinidx != chan->eventoutidx) {
 			spin_unlock_irqrestore(&chan->lock, flags);
-			return -ELAST;
+			return _RETVAL(ELAST);
 		}
 		res = chan->inwritebuf;
 		spin_unlock_irqrestore(&chan->lock, flags);
 		if (res >= 0)
 			break;
-		if (file->f_flags & O_NONBLOCK) {
+		if (ioflag & O_NONBLOCK) {
 #ifdef BUFFER_DEBUG
 			printk("Error: Nonblock\n");
 #endif
-			return -EAGAIN;
+			return _RETVAL(EAGAIN);
 		}
 		/* Wait for something to be available */
 		rv = schluffen(&chan->writebufq);
@@ -2177,9 +2552,12 @@
 				pass = left;
 				if (pass > 128)
 					pass = 128;
-				if (copy_from_user(lindata, usrbuf + (pos << 1), pass << 1)) {
-					return -EFAULT;
-				}
+#if defined(__FreeBSD__)
+				if (uiomove(lindata, pass << 1, uio))
+#else
+				if (copy_from_user(lindata, usrbuf + (pos << 1), pass << 1))
+#endif
+					return _RETVAL(EFAULT);
 				left -= pass;
 				for (x = 0; x < pass; x++)
 					chan->writebuf[res][x + pos] = DAHDI_LIN2X(lindata[x], chan);
@@ -2187,9 +2565,12 @@
 			}
 			chan->writen[res] = amnt >> 1;
 		} else {
-			if (copy_from_user(chan->writebuf[res], usrbuf, amnt)) {
-				return -EFAULT;
-			}
+#if defined(__FreeBSD__)
+			if (uiomove(chan->writebuf[res], amnt, uio))
+#else
+			if (copy_from_user(chan->writebuf[res], usrbuf, amnt))
+#endif
+				return _RETVAL(EFAULT);
 			chan->writen[res] = amnt;
 		}
 		chan->writeidx[res] = 0;
@@ -2234,28 +2615,28 @@
 		if (chan->flags & DAHDI_FLAG_NOSTDTXRX && chan->span->hdlc_hard_xmit)
 			chan->span->hdlc_hard_xmit(chan);
 	}
-	return amnt;
+	return FOP_IO_SUCCESS(amnt);
 }
 
-static int dahdi_ctl_open(struct inode *inode, struct file *file)
+static int dahdi_ctl_open(FOP_ARGS_DECL)
 {
 	/* Nothing to do, really */
 	return 0;
 }
 
-static int dahdi_chan_open(struct inode *inode, struct file *file)
+static int dahdi_chan_open(FOP_ARGS_DECL)
 {
 	/* Nothing to do here for now either */
 	return 0;
 }
 
-static int dahdi_ctl_release(struct inode *inode, struct file *file)
+static int dahdi_ctl_release(FOP_ARGS_DECL)
 {
 	/* Nothing to do */
 	return 0;
 }
 
-static int dahdi_chan_release(struct inode *inode, struct file *file)
+static int dahdi_chan_release(FOP_ARGS_DECL)
 {
 	/* Nothing to do for now */
 	return 0;
@@ -2426,7 +2807,7 @@
 
 	/* Can't hang up a clear channel */
 	if (chan->flags & (DAHDI_FLAG_CLEAR | DAHDI_FLAG_NOSTDTXRX))
-		return -EINVAL;
+		return _RETVAL(EINVAL);
 
 	chan->kewlonhook = 0;
 
@@ -2615,17 +2996,20 @@
 	return 0;
 }
 
-static int dahdi_timing_open(struct inode *inode, struct file *file)
+static int dahdi_timing_open(FOP_ARGS_DECL)
 {
 	struct dahdi_timer *t;
 	unsigned long flags;
 
 	if (!(t = kzalloc(sizeof(*t), GFP_KERNEL)))
-		return -ENOMEM;
+		return _RETVAL(ENOMEM);
 
 	init_waitqueue_head(&t->sel);
 	INIT_LIST_HEAD(&t->list);
-	file->private_data = t;
+#if defined(__FreeBSD__)
+	TASK_INIT(&t->selwakeup_task, 0, handle_selwakeup, &t->sel);
+#endif
+	dahdi_set_private_data(file, t);
 
 	spin_lock_irqsave(&zaptimerlock, flags);
 	list_add(&t->list, &zaptimers);
@@ -2634,12 +3018,13 @@
 	return 0;
 }
 
-static int dahdi_timer_release(struct inode *inode, struct file *file)
+static int dahdi_timer_release(FOP_ARGS_DECL)
 {
-	struct dahdi_timer *t, *cur, *next;
+	struct dahdi_timer *t;
+	struct dahdi_timer *cur, *next;
 	unsigned long flags;
 
-	if (!(t = file->private_data))
+	if (!(t = dahdi_get_private_data(file)))
 		return 0;
 
 	spin_lock_irqsave(&zaptimerlock, flags);
@@ -2658,12 +3043,15 @@
 		return 0;
 	}
 
+#if defined(__FreeBSD__)
+	taskqueue_drain(taskqueue_fast, &t->selwakeup_task);
+#endif
 	kfree(cur);
 
 	return 0;
 }
 
-static int dahdi_specchan_open(struct inode *inode, struct file *file, int unit)
+static int dahdi_specchan_open(FOP_ARGS_DECL, int unit)
 {
 	int res = 0;
 	struct dahdi_chan *const chan = chans[unit];
@@ -2671,11 +3059,11 @@
 	if (chan && chan->sig) {
 		/* Make sure we're not already open, a net device, or a slave device */
 		if (chan->flags & DAHDI_FLAG_NETDEV)
-			res = -EBUSY;
+			res = _RETVAL(EBUSY);
 		else if (chan->master != chan)
-			res = -EBUSY;
+			res = _RETVAL(EBUSY);
 		else if ((chan->sig & __DAHDI_SIG_DACS) == __DAHDI_SIG_DACS)
-			res = -EBUSY;
+			res = _RETVAL(EBUSY);
 		else if (!test_and_set_bit(DAHDI_FLAGBIT_OPEN, &chan->flags)) {
 			unsigned long flags;
 			res = initialize_channel(chan);
@@ -2688,9 +3076,11 @@
 			if (chan->flags & DAHDI_FLAG_PSEUDO)
 				chan->flags |= DAHDI_FLAG_AUDIO;
 			if (chan->span) {
+#if !defined(__FreeBSD__)
 				if (!try_module_get(chan->span->owner))
-					res = -ENXIO;
-				else if (chan->span->open)
+					return _RETVAL(ENXIO);
+#endif
+				if (chan->span->open)
 					res = chan->span->open(chan);
 			}
 			if (!res) {
@@ -2702,14 +3092,14 @@
 				clear_bit(DAHDI_FLAGBIT_OPEN, &chan->flags);
 			}
 		} else {
-			res = -EBUSY;
+			res = _RETVAL(EBUSY);
 		}
 	} else
-		res = -ENXIO;
+		res = _RETVAL(ENXIO);
 	return res;
 }
 
-static int dahdi_specchan_release(struct inode *node, struct file *file, int unit)
+static int dahdi_specchan_release(FOP_ARGS_DECL, int unit)
 {
 	int res=0;
 	unsigned long flags;
@@ -2723,17 +3113,22 @@
 		spin_unlock_irqrestore(&chan->lock, flags);
 		close_channel(chan);
 		if (chan->span) {
+#if !defined(__FreeBSD__)
 			struct module *owner = chan->span->owner;
+#endif
 
 			if (chan->span->close)
 				res = chan->span->close(chan);
+#if !defined(__FreeBSD__)
 			module_put(owner);
+#endif
 		}
 		/* The channel might be destroyed by low-level driver span->close() */
 		if (chans[unit])
 			clear_bit(DAHDI_FLAGBIT_OPEN, &chans[unit]->flags);
 	} else
-		res = -ENXIO;
+		res = _RETVAL(ENXIO);
+
 	return res;
 }
 
@@ -2780,24 +3175,27 @@
 	}
 }
 
-static int dahdi_open(struct inode *inode, struct file *file)
+static int dahdi_open(FOP_OPEN_ARGS_DECL)
 {
 	int unit = UNIT(file);
+	int res;
 	struct dahdi_chan *chan;
+
 	/* Minor 0: Special "control" descriptor */
 	if (!unit)
-		return dahdi_ctl_open(inode, file);
-	if (unit == 250) {
+		return dahdi_ctl_open(FOP_ARGS);
+	if (unit == DAHDI_MINOR_TRANSCODE) {
+#if !defined(__FreeBSD__)
 		if (!dahdi_transcode_fops) {
 			if (request_module("dahdi_transcode")) {
-				return -ENXIO;
+				return _RETVAL(ENXIO);
 			}
 		}
 #if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,0)
 		__MOD_INC_USE_COUNT (dahdi_transcode_fops->owner);
 #else
 		if (!try_module_get(dahdi_transcode_fops->owner)) {
-			return -ENXIO;
+			return _RETVAL(ENXIO);
 		}
 #endif
 		if (dahdi_transcode_fops && dahdi_transcode_fops->open) {
@@ -2807,28 +3205,35 @@
 			 * file_operations table. */
 			 WARN_ON(1);
 		}
-		return -ENXIO;
+#endif /* !__FreeBSD__ */
+		return _RETVAL(ENXIO);
 	}
-	if (unit == 253) {
+	if (unit == DAHDI_MINOR_TIMER) {
 		if (can_open_timer()) {
-			return dahdi_timing_open(inode, file);
+			return dahdi_timing_open(FOP_ARGS);
 		} else {
-			return -ENXIO;
+			return _RETVAL(ENXIO);
 		}
 	}
-	if (unit == 254)
-		return dahdi_chan_open(inode, file);
-	if (unit == 255) {
+	if (unit == DAHDI_MINOR_CHANNEL)
+		return dahdi_chan_open(FOP_ARGS);
+	if (unit == DAHDI_MINOR_PSEUDO) {
 		chan = dahdi_alloc_pseudo();
-		if (chan) {
-			file->private_data = chan;
-			return dahdi_specchan_open(inode, file, chan->channo);
-		} else {
-			return -ENXIO;
+		if (!chan)
+			return _RETVAL(ENXIO);
+
+		res = dahdi_specchan_open(FOP_ARGS, chan->channo);
+		if (res != 0)
+			return res;
+		dahdi_set_private_data(file, chan);
+#if defined(__FreeBSD__)
+		dahdi_set_flags(file, oflags);
+#endif
+		return (res);
 		}
+
+	return dahdi_specchan_open(FOP_ARGS, unit);
 	}
-	return dahdi_specchan_open(inode, file, unit);
-}
 
 #if 0
 static int dahdi_open(struct inode *inode, struct file *file)
